"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Fields = exports.Queries = exports.RequestIP = exports.RequestPath = exports.Files = exports.File = exports.Headers = exports.Param = exports.Query = exports.Body = exports.Session = exports.createRequestParamDecorator = exports.RouteParamTypes = void 0;
const __1 = require("../");
var RouteParamTypes;
(function (RouteParamTypes) {
    RouteParamTypes[RouteParamTypes["QUERY"] = 0] = "QUERY";
    RouteParamTypes[RouteParamTypes["BODY"] = 1] = "BODY";
    RouteParamTypes[RouteParamTypes["PARAM"] = 2] = "PARAM";
    RouteParamTypes[RouteParamTypes["HEADERS"] = 3] = "HEADERS";
    RouteParamTypes[RouteParamTypes["SESSION"] = 4] = "SESSION";
    RouteParamTypes[RouteParamTypes["FILESTREAM"] = 5] = "FILESTREAM";
    RouteParamTypes[RouteParamTypes["FILESSTREAM"] = 6] = "FILESSTREAM";
    RouteParamTypes[RouteParamTypes["NEXT"] = 7] = "NEXT";
    RouteParamTypes[RouteParamTypes["REQUEST_PATH"] = 8] = "REQUEST_PATH";
    RouteParamTypes[RouteParamTypes["REQUEST_IP"] = 9] = "REQUEST_IP";
    RouteParamTypes[RouteParamTypes["QUERIES"] = 10] = "QUERIES";
    RouteParamTypes[RouteParamTypes["FIELDS"] = 11] = "FIELDS";
    RouteParamTypes[RouteParamTypes["CUSTOM"] = 12] = "CUSTOM";
})(RouteParamTypes = exports.RouteParamTypes || (exports.RouteParamTypes = {}));
const createParamMapping = function (type) {
    return (propertyData, pipes) => {
        return (0, __1.createCustomParamDecorator)(__1.WEB_ROUTER_PARAM_KEY, {
            type,
            propertyData,
        }, {
            pipes,
        });
    };
};
const createRequestParamDecorator = function (transform, pipes) {
    return createParamMapping(RouteParamTypes.CUSTOM)(transform, pipes);
};
exports.createRequestParamDecorator = createRequestParamDecorator;
const Session = (property, pipes) => createParamMapping(RouteParamTypes.SESSION)(property, pipes);
exports.Session = Session;
const Body = (property, pipes) => createParamMapping(RouteParamTypes.BODY)(property, pipes);
exports.Body = Body;
const Query = (property, pipes) => createParamMapping(RouteParamTypes.QUERY)(property, pipes);
exports.Query = Query;
const Param = (property, pipes) => createParamMapping(RouteParamTypes.PARAM)(property, pipes);
exports.Param = Param;
const Headers = (property, pipes) => createParamMapping(RouteParamTypes.HEADERS)(property, pipes);
exports.Headers = Headers;
const File = (property, pipes) => createParamMapping(RouteParamTypes.FILESTREAM)(property, pipes);
exports.File = File;
const Files = (property, pipes) => createParamMapping(RouteParamTypes.FILESSTREAM)(property, pipes);
exports.Files = Files;
const RequestPath = () => createParamMapping(RouteParamTypes.REQUEST_PATH)();
exports.RequestPath = RequestPath;
const RequestIP = () => createParamMapping(RouteParamTypes.REQUEST_IP)();
exports.RequestIP = RequestIP;
const Queries = (property, pipes) => createParamMapping(RouteParamTypes.QUERIES)(property, pipes);
exports.Queries = Queries;
const Fields = (property, pipes) => createParamMapping(RouteParamTypes.FIELDS)(property, pipes);
exports.Fields = Fields;
//# sourceMappingURL=paramMapping.js.map